#include <stdio.h>
#include <stdlib.h>
#include <limits.h>

#define NMAX 10                  /* 点の数の上限 */
int graph[NMAX + 1][NMAX + 1];   /* 辺(関連)の有無 */
int n;                           /* 点の数 */

#define START  1  /* 出発点 */
#define FALSE  0
#define TRUE   1

void inputgraph(void);            /* グラフデータ読込み */

int main()
{
  int i, j, next, min;
  static char visited[NMAX + 1];
  static int leastdistance[NMAX + 1], previous[NMAX + 1];
  
  inputgraph();  /* グラフデータ graph[][] の読込み */
  for (i = 1; i <= n; i++) {
    visited[i] = FALSE;  leastdistance[i] = INT_MAX;
  }
  leastdistance[START] = 0;  next = START;
  do {
    i = next;  visited[i] = TRUE;  min = INT_MAX;
    for (j = 1; j <= n; j++) {
      if (visited[j]) continue;
      if (graph[i][j] < INT_MAX &&
	  leastdistance[i] + graph[i][j] < leastdistance[j]) {
	leastdistance[j] = leastdistance[i] + graph[i][j];
	previous[j] = i;
      }
      if (leastdistance[j] < min) {
	min = leastdistance[j];  next = j;
      }
    }
  } while (min < INT_MAX);
  printf("点  直前の点  最短距離\n");
  for (i = 1; i <= n; i++)
    if (i != START && visited[i])
      printf("%2d%10d%10d\n", i, previous[i], leastdistance[i]);
  return EXIT_SUCCESS;
}
